/* 
 
  it is my first shader ever.

                             mr.samadani

                                         */



#include "ReShade.fxh"
#include "ReShadeUI.fxh"

uniform float Strength < __UNIFORM_SLIDER_FLOAT1 // power of whole Effect
	ui_min = 0.0; ui_max = 1.0; ui_tooltip ="power of whole Effect"; ui_category = "Global settings";
> = 1;
uniform float Threshold < __UNIFORM_SLIDER_FLOAT1  //  power of detale
	ui_min = 0.0; ui_max = 1.0; ui_tooltip ="power of detale"; ui_category = "Global settings";
> = 0.2;
uniform float TintStrength < __UNIFORM_SLIDER_FLOAT1// power of tint of effect 
	ui_min = 0.0; ui_max = 1.0; ui_tooltip ="power of tint of effect"; ui_category = "Global settings";
> = 0;
uniform float3 LightTint < __UNIFORM_COLOR_FLOAT3 // color of tint
 ui_tooltip ="power of tint of effect"; ui_category = "Global settings";
> = float3(1, 0.9, 0.6);

uniform bool givemesky <
ui_label = "sky mask";
	ui_tooltip = "Enable for adjustment fog distance";
	ui_category = "fog settings";
	> = true;

	uniform float FarPlane <
	ui_label = "Far Plane adjustment";
	ui_tooltip = "Adjust Normal Map strength";
	ui_type = "drag";
	ui_min = 0.0; ui_max = 1000.0; ui_step = 0.2;
	ui_category = "fog settings";
> = 1000.0;

uniform float DepthStrength < __UNIFORM_SLIDER_FLOAT1 // power of Effect
	ui_min = 0.0; ui_max = 1.0; 	ui_category = "fog settings";
> = 0.8f;

uniform float DepthMultiplier < __UNIFORM_SLIDER_FLOAT1 // power of Effect
	ui_min = 0.0; ui_max = 1.0; 	ui_category = "fog settings";
> = 1;
uniform bool ViewMask <
	ui_label = "View Mask";
	ui_tooltip = "Mask reflection for:\nDEPTH = 1.0";
	ui_category = "debug settings";
> = false;
uniform float ViewMaskSlider < __UNIFORM_SLIDER_FLOAT1 // power of Effect
ui_label = "View Mask Slider";
	ui_min = 0.0; ui_max = 1.0; ui_category = "debug settings";
> = 0.5;


float3 SatPass(float4 vois : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
       float3 colorr = ReShade::GetLinearizedDepth(texcoord) ;
    float3 SkyMask = 0;
	if(givemesky) SkyMask = colorr ;
	if(givemesky) const float N = 1.0;
	if(givemesky) SkyMask /= FarPlane - SkyMask * (FarPlane - N);

 
     colorr = colorr * DepthMultiplier;
    float4 colorInput = tex2D(ReShade::BackBuffer, texcoord);
	float3 col = tex2D(ReShade::BackBuffer, texcoord).rgb;
	float3 lumCoeff = float3(0.2126, 0.7152, 0.0722);
	float luma = dot(lumCoeff, colorInput.rgb);
	float mask = 1-luma;
	mask = mask +  luma*Threshold ;
	mask = lerp (1 ,mask ,Strength);
	float3 tluma = luma *LightTint;
	tluma = lerp (luma ,tluma ,TintStrength);
	//adding depht

	float3 addativeDepth = mask - colorr;
	 addativeDepth = clamp (addativeDepth,0,1);

	mask = lerp(mask,addativeDepth ,DepthStrength);

	float3 finalmask =  mask +SkyMask - mask *SkyMask;
	finalmask = lerp (1 ,finalmask ,Strength); 

	float3 final = lerp( tluma , col ,   finalmask );

	if (texcoord.x > ViewMaskSlider) if (ViewMask) final = 1 - finalmask;

	return final; 

	}


	technique LightBasedSaturation	
{
	pass
	{
		VertexShader = PostProcessVS;
		PixelShader = SatPass;
	}
}
